Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/caldyn_loc.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/caldyn_loc.f90	(revision 5101)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/caldyn_loc.f90	(revision 5101)
@@ -0,0 +1,182 @@
+! $Id: $
+
+SUBROUTINE caldyn_loc &
+        (itau, ucov, vcov, teta, ps, masse, pk, pkf, phis, &
+        phi, conser, du, dv, dteta, dp, w, pbaru, pbarv, time)
+  USE parallel_lmdz
+  USE Write_Field_loc
+  USE caldyn_mod, ONLY: vcont, ucont, ang, p, massebx, masseby, &
+          vorpot, ecin, bern, massebxy, convm
+  USE comvert_mod, ONLY: ap, bp
+  USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_DEBUGIO
+
+  IMPLICIT NONE
+
+  !=======================================================================
+
+  !  Auteur :  P. Le Van
+
+  !   Objet:
+  !   ------
+
+  !   Calcul des tendances dynamiques.
+
+  ! Modif 04/93 F.Forget
+  !=======================================================================
+
+  !-----------------------------------------------------------------------
+  !   0. Declarations:
+  !   ----------------
+
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+
+  !   Arguments:
+  !   ----------
+
+  LOGICAL, INTENT(IN) :: conser ! triggers printing some diagnostics ! not used
+  INTEGER, INTENT(IN) :: itau ! time step index ! not used
+  REAL, INTENT(IN) :: vcov(ijb_v:ije_v, llm) ! covariant meridional wind
+  REAL, INTENT(IN) :: ucov(ijb_u:ije_u, llm) ! covariant zonal wind
+  REAL, INTENT(IN) :: teta(ijb_u:ije_u, llm) ! potential temperature
+  REAL, INTENT(IN) :: ps(ijb_u:ije_u) ! surface pressure
+  REAL, INTENT(IN) :: phis(ijb_u:ije_u) ! geopotential at the surface
+  REAL, INTENT(IN) :: pk(iip1, jjb_u:jje_u, llm) ! Exner at mid-layer
+  REAL, INTENT(IN) :: pkf(ijb_u:ije_u, llm) ! filtered Exner
+  REAL, INTENT(IN) :: phi(ijb_u:ije_u, llm) ! geopotential
+  REAL, INTENT(OUT) :: masse(ijb_u:ije_u, llm) ! air mass
+  REAL, INTENT(OUT) :: dv(ijb_v:ije_v, llm) ! tendency on vcov
+  REAL, INTENT(OUT) :: du(ijb_u:ije_u, llm) ! tendency on ucov
+  REAL, INTENT(OUT) :: dteta(ijb_u:ije_u, llm) ! tenddency on teta
+  REAL, INTENT(OUT) :: dp(ijb_u:ije_u) ! tendency on ps
+  REAL, INTENT(OUT) :: w(ijb_u:ije_u, llm) ! vertical velocity
+  REAL, INTENT(OUT) :: pbaru(ijb_u:ije_u, llm) ! mass flux in the zonal direction
+  REAL, INTENT(OUT) :: pbarv(ijb_v:ije_v, llm) ! mass flux in the meridional direction
+  REAL, INTENT(IN) :: time ! current time
+
+  !   Local:
+  !   ------
+
+  INTEGER :: ij, l, ijb, ije, ierr
+
+
+  !-----------------------------------------------------------------------
+  !   Compute dynamical tendencies:
+  !--------------------------------
+
+  ! ! compute contravariant winds ucont() and vcont
+  CALL covcont_loc  (llm, ucov, vcov, ucont, vcont)
+  ! ! compute pressure p()
+  CALL pression_loc (ip1jmp1, ap, bp, ps, p)
+  !ym      CALL psextbar (   ps   , psexbarxy                          )
+  !$OMP BARRIER
+  ! ! compute mass in each atmospheric mesh: masse()
+  CALL massdair_loc (p, masse)
+  ! ! compute X and Y-averages of mass, massebx() and masseby()
+  CALL massbar_loc  (masse, massebx, masseby)
+  ! ! compute XY-average of mass, massebxy()
+  CALL massbarxy_loc(masse, massebxy)
+  ! ! compute mass fluxes pbaru() and pbarv()
+  CALL flumass_loc  (massebx, masseby, vcont, ucont, pbaru, pbarv)
+  ! ! compute dteta() , horizontal converging flux of theta
+  CALL dteta1_loc   (teta, pbaru, pbarv, dteta)
+  ! ! compute convm(), horizontal converging flux of mass
+  CALL convmas1_loc  (pbaru, pbarv, convm)
+  !$OMP BARRIER
+  CALL convmas2_loc  (convm)
+  !$OMP BARRIER
+  IF (CPPKEY_DEBUGIO) THEN
+    CALL WriteField_u('ucont', ucont)
+    CALL WriteField_v('vcont', vcont)
+    CALL WriteField_u('p', p)
+    CALL WriteField_u('masse', masse)
+    CALL WriteField_u('massebx', massebx)
+    CALL WriteField_v('masseby', masseby)
+    CALL WriteField_v('massebxy', massebxy)
+    CALL WriteField_u('pbaru', pbaru)
+    CALL WriteField_v('pbarv', pbarv)
+    CALL WriteField_u('dteta', dteta)
+    CALL WriteField_u('convm', convm)
+  END IF
+
+  !$OMP BARRIER
+  !$OMP MASTER
+  ijb = ij_begin
+  ije = ij_end
+  ! ! compute pressure variation due to mass convergence
+  DO ij = ijb, ije
+    dp(ij) = convm(ij, 1) / airesurg(ij)
+  ENDDO
+  !$OMP END MASTER
+  !$OMP BARRIER
+
+  ! ! compute vertical velocity w()
+  CALL vitvert_loc (convm, w)
+  ! ! compute potential vorticity vorpot()
+  CALL tourpot_loc (vcov, ucov, massebxy, vorpot)
+  ! ! compute rotation induced du() and dv()
+  CALL dudv1_loc   (vorpot, pbaru, pbarv, du, dv)
+
+  IF (CPPKEY_DEBUGIO) THEN
+    CALL WriteField_u('w', w)
+    CALL WriteField_v('vorpot', vorpot)
+    CALL WriteField_u('du', du)
+    CALL WriteField_v('dv', dv)
+  END IF
+
+  ! ! compute kinetic energy ecin()
+  CALL enercin_loc (vcov, ucov, vcont, ucont, ecin)
+  ! ! compute Bernouilli function bern()
+  CALL bernoui_loc (ip1jmp1, llm, phi, ecin, bern)
+  ! ! compute and add du() and dv() contributions from Bernouilli and pressure
+  CALL dudv2_loc   (teta, pkf, bern, du, dv)
+
+  IF (CPPKEY_DEBUGIO) THEN
+    CALL WriteField_u('ecin', ecin)
+    CALL WriteField_u('bern', bern)
+    CALL WriteField_u('du', du)
+    CALL WriteField_v('dv', dv)
+    CALL WriteField_u('pkf', pkf)
+  END IF
+
+  ijb = ij_begin - iip1
+  ije = ij_end + iip1
+
+  if (pole_nord) ijb = ij_begin
+  if (pole_sud) ije = ij_end
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm
+    DO ij = ijb, ije
+      ang(ij, l) = ucov(ij, l) + constang(ij)
+    ENDDO
+  ENDDO
+  !$OMP END DO
+
+  ! ! compute vertical advection contributions to du(), dv() and dteta()
+  CALL advect_new_loc(ang, vcov, teta, w, massebx, masseby, du, dv, dteta)
+
+  !  WARNING probleme de peridocite de dv sur les PC/linux. Pb d'arrondi
+  ! probablement. Observe sur le code compile avec pgf90 3.0-1
+  ijb = ij_begin
+  ije = ij_end
+  if (pole_sud) ije = ij_end - iip1
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm
+    DO ij = ijb, ije, iip1
+      IF(dv(ij, l)/=dv(ij + iim, l))  THEN
+        ! PRINT *,'!!!ATTENTION!!! probleme de periodicite sur vcov',
+        !    ,   ' dans caldyn'
+        ! PRINT *,' l,  ij = ', l, ij, ij+iim,dv(ij+iim,l),dv(ij,l)
+        dv(ij + iim, l) = dv(ij, l)
+      endif
+    enddo
+  enddo
+  !$OMP END DO NOWAIT
+
+  ! Ehouarn: NB: output of control variables not implemented...
+
+  RETURN
+END SUBROUTINE caldyn_loc
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/call_dissip_mod.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/call_dissip_mod.f90	(revision 5101)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/call_dissip_mod.f90	(revision 5101)
@@ -0,0 +1,322 @@
+MODULE call_dissip_mod
+
+  REAL, POINTER, SAVE :: ucov(:, :)
+  REAL, POINTER, SAVE :: vcov(:, :)
+  REAL, POINTER, SAVE :: teta(:, :)
+  REAL, POINTER, SAVE :: p(:, :)
+  REAL, POINTER, SAVE :: pk(:, :)
+
+  REAL, POINTER, SAVE :: ucont(:, :)
+  REAL, POINTER, SAVE :: vcont(:, :)
+  REAL, POINTER, SAVE :: ecin(:, :)
+  REAL, POINTER, SAVE :: ecin0(:, :)
+  REAL, POINTER, SAVE :: dudis(:, :)
+  REAL, POINTER, SAVE :: dvdis(:, :)
+  REAL, POINTER, SAVE :: dtetadis(:, :)
+  REAL, POINTER, SAVE :: dtetaecdt(:, :)
+
+
+CONTAINS
+
+  SUBROUTINE call_dissip_allocate
+    USE bands
+    USE allocate_field_mod
+    USE parallel_lmdz
+    USE dimensions_mod
+    USE dissip_mod, ONLY: dissip_allocate
+    IMPLICIT NONE
+    TYPE(distrib), POINTER :: d
+    d => distrib_dissip
+
+    CALL allocate_u(ucov, llm, d)
+    ucov(:, :) = 0
+    CALL allocate_v(vcov, llm, d)
+    vcov(:, :) = 0
+    CALL allocate_u(teta, llm, d)
+    CALL allocate_u(p, llmp1, d)
+    CALL allocate_u(pk, llm, d)
+    CALL allocate_u(ucont, llm, d)
+    CALL allocate_v(vcont, llm, d)
+    CALL allocate_u(ecin, llm, d)
+    CALL allocate_u(ecin0, llm, d)
+    CALL allocate_u(dudis, llm, d)
+    CALL allocate_v(dvdis, llm, d)
+    CALL allocate_u(dtetadis, llm, d)
+    CALL allocate_u(dtetaecdt, llm, d)
+
+    CALL dissip_allocate
+
+  END SUBROUTINE call_dissip_allocate
+
+  SUBROUTINE call_dissip_switch_dissip(dist)
+    USE allocate_field_mod
+    USE bands
+    USE parallel_lmdz
+    USE dissip_mod, ONLY: dissip_switch_dissip
+    IMPLICIT NONE
+    TYPE(distrib), INTENT(IN) :: dist
+
+    CALL switch_u(ucov, distrib_dissip, dist)
+    CALL switch_v(vcov, distrib_dissip, dist)
+    CALL switch_u(teta, distrib_dissip, dist)
+    CALL switch_u(p, distrib_dissip, dist)
+    CALL switch_u(pk, distrib_dissip, dist)
+    CALL switch_u(ucont, distrib_dissip, dist)
+    CALL switch_v(vcont, distrib_dissip, dist)
+    CALL switch_u(ecin, distrib_dissip, dist)
+    CALL switch_u(ecin0, distrib_dissip, dist)
+    CALL switch_u(dudis, distrib_dissip, dist)
+    CALL switch_v(dvdis, distrib_dissip, dist)
+    CALL switch_u(dtetadis, distrib_dissip, dist)
+    CALL switch_u(dtetaecdt, distrib_dissip, dist)
+
+    CALL dissip_switch_dissip(dist)
+
+  END SUBROUTINE call_dissip_switch_dissip
+
+
+  SUBROUTINE call_dissip(ucov_dyn, vcov_dyn, teta_dyn, p_dyn, pk_dyn, ps_dyn)
+    USE dimensions_mod
+    USE parallel_lmdz
+    USE times
+    USE mod_hallo
+    USE Bands
+    USE vampir
+    USE write_field_loc
+    USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_DEBUGIO
+
+    IMPLICIT NONE
+    INCLUDE 'comgeom.h'
+    REAL, INTENT(INOUT) :: ucov_dyn(ijb_u:ije_u, llm) ! covariant zonal wind
+    REAL, INTENT(INOUT) :: vcov_dyn(ijb_v:ije_v, llm) ! covariant meridional wind
+    REAL, INTENT(INOUT) :: teta_dyn(ijb_u:ije_u, llm) ! covariant meridional wind
+    REAL, INTENT(INOUT) :: p_dyn(ijb_u:ije_u, llmp1) ! pressure at interlayer
+    REAL, INTENT(INOUT) :: pk_dyn(ijb_u:ije_u, llm) ! Exner at midlayer
+    REAL, INTENT(INOUT) :: ps_dyn(ijb_u:ije_u) ! surface pressure
+    REAL :: tppn(iim), tpps(iim)
+    REAL :: tpn, tps
+
+    REAL  SSUM
+    LOGICAL, PARAMETER :: dissip_conservative = .TRUE.
+    TYPE(Request), SAVE :: Request_dissip
+    !$OMP THREADPRIVATE(Request_dissip )
+    INTEGER :: ij, l, ijb, ije
+
+
+    !$OMP MASTER
+    CALL suspend_timer(timer_caldyn)
+
+    !       print*,'Entree dans la dissipation : Iteration No ',true_itau
+    !   calcul de l'energie cinetique avant dissipation
+    !       print *,'Passage dans la dissipation'
+
+    CALL VTb(VThallo)
+    !$OMP END MASTER
+
+    !$OMP BARRIER
+
+    CALL Register_SwapField_u(ucov_dyn, ucov, distrib_dissip, Request_dissip, up = 1, down = 1)
+    CALL Register_SwapField_v(vcov_dyn, vcov, distrib_dissip, Request_dissip, up = 1, down = 1)
+    CALL Register_SwapField_u(teta_dyn, teta, distrib_dissip, Request_dissip)
+    CALL Register_SwapField_u(p_dyn, p, distrib_dissip, Request_dissip)
+    CALL Register_SwapField_u(pk_dyn, pk, distrib_dissip, Request_dissip)
+
+    CALL SendRequest(Request_dissip)
+    !$OMP BARRIER
+    CALL WaitRequest(Request_dissip)
+
+    !$OMP BARRIER
+    !$OMP MASTER
+    CALL set_distrib(distrib_dissip)
+    CALL VTe(VThallo)
+    CALL VTb(VTdissipation)
+    CALL start_timer(timer_dissip)
+    !$OMP END MASTER
+    !$OMP BARRIER
+
+    CALL covcont_loc(llm, ucov, vcov, ucont, vcont)
+    CALL enercin_loc(vcov, ucov, vcont, ucont, ecin0)
+
+    !   dissipation
+
+    !        CALL FTRACE_REGION_BEGIN("dissip")
+    CALL dissip_loc(vcov, ucov, teta, p, dvdis, dudis, dtetadis)
+
+    IF (CPPKEY_DEBUGIO) THEN
+      CALL WriteField_u('dudis', dudis)
+      CALL WriteField_v('dvdis', dvdis)
+      CALL WriteField_u('dtetadis', dtetadis)
+    END IF
+
+    !      CALL FTRACE_REGION_END("dissip")
+
+    ijb = ij_begin
+    ije = ij_end
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    DO l = 1, llm
+      ucov(ijb:ije, l) = ucov(ijb:ije, l) + dudis(ijb:ije, l)
+    ENDDO
+    !$OMP END DO NOWAIT
+
+    IF (pole_sud) ije = ije - iip1
+
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    DO l = 1, llm
+      vcov(ijb:ije, l) = vcov(ijb:ije, l) + dvdis(ijb:ije, l)
+    ENDDO
+    !$OMP END DO NOWAIT
+
+    !       teta=teta+dtetadis
+
+
+    !------------------------------------------------------------------------
+    IF (dissip_conservative) THEN
+      !       On rajoute la tendance due a la transform. Ec -> E therm. cree
+      !       lors de la dissipation
+      !$OMP BARRIER
+      !$OMP MASTER
+      CALL suspend_timer(timer_dissip)
+      CALL VTb(VThallo)
+      !$OMP END MASTER
+      CALL Register_Hallo_u(ucov, llm, 1, 1, 1, 1, Request_Dissip)
+      CALL Register_Hallo_v(vcov, llm, 1, 1, 1, 1, Request_Dissip)
+      CALL SendRequest(Request_Dissip)
+      !$OMP BARRIER
+      CALL WaitRequest(Request_Dissip)
+      !$OMP MASTER
+      CALL VTe(VThallo)
+      CALL resume_timer(timer_dissip)
+      !$OMP END MASTER
+      !$OMP BARRIER
+      CALL covcont_loc(llm, ucov, vcov, ucont, vcont)
+      CALL enercin_loc(vcov, ucov, vcont, ucont, ecin)
+
+      ijb = ij_begin
+      ije = ij_end
+      !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l = 1, llm
+        DO ij = ijb, ije
+          dtetaecdt(ij, l) = (ecin0(ij, l) - ecin(ij, l)) / pk(ij, l)
+          dtetadis(ij, l) = dtetadis(ij, l) + dtetaecdt(ij, l)
+        ENDDO
+      ENDDO
+      !$OMP END DO NOWAIT
+
+    ENDIF
+
+    ijb = ij_begin
+    ije = ij_end
+
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    DO l = 1, llm
+      DO ij = ijb, ije
+        teta(ij, l) = teta(ij, l) + dtetadis(ij, l)
+      ENDDO
+    ENDDO
+    !$OMP END DO NOWAIT
+
+    !------------------------------------------------------------------------
+
+
+    !    .......        P. Le Van (  ajout  le 17/04/96  )   ...........
+    !   ...      Calcul de la valeur moyenne, unique de h aux poles  .....
+
+    ijb = ij_begin
+    ije = ij_end
+
+    IF (pole_nord) THEN
+
+      !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l = 1, llm
+        DO ij = 1, iim
+          tppn(ij) = aire(ij) * teta(ij, l)
+        ENDDO
+        tpn = SSUM(iim, tppn, 1) / apoln
+
+        DO ij = 1, iip1
+          teta(ij, l) = tpn
+        ENDDO
+      ENDDO
+      !$OMP END DO NOWAIT
+
+      if (1 == 0) then
+        !!! Ehouarn: lines here 1) kill 1+1=2 in the dynamics
+        !!!                     2) should probably not be here anyway
+        !!! but are kept for those who would want to revert to previous behaviour
+        !$OMP MASTER
+        DO ij = 1, iim
+          tppn(ij) = aire(ij) * ps_dyn (ij)
+        ENDDO
+        tpn = SSUM(iim, tppn, 1) / apoln
+
+        DO ij = 1, iip1
+          ps_dyn(ij) = tpn
+        ENDDO
+        !$OMP END MASTER
+
+      ENDIF ! of if (1 == 0)
+    endif ! of of (pole_nord)
+
+    IF (pole_sud) THEN
+
+      !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l = 1, llm
+        DO ij = 1, iim
+          tpps(ij) = aire(ij + ip1jm) * teta(ij + ip1jm, l)
+        ENDDO
+
+        tps = SSUM(iim, tpps, 1) / apols
+
+        DO ij = 1, iip1
+          teta(ij + ip1jm, l) = tps
+        ENDDO
+      ENDDO
+      !$OMP END DO NOWAIT
+
+      if (1 == 0) then
+        !!! Ehouarn: lines here 1) kill 1+1=2 in the dynamics
+        !!!                     2) should probably not be here anyway
+        !!! but are kept for those who would want to revert to previous behaviour
+        !$OMP MASTER
+        DO ij = 1, iim
+          tpps(ij) = aire(ij + ip1jm) * ps_dyn (ij + ip1jm)
+        ENDDO
+        tps = SSUM(iim, tpps, 1) / apols
+
+        DO ij = 1, iip1
+          ps_dyn(ij + ip1jm) = tps
+        ENDDO
+        !$OMP END MASTER
+      ENDIF ! of if (1 == 0)
+    endif ! of if (pole_sud)
+
+
+    !$OMP BARRIER
+    !$OMP MASTER
+    CALL VTe(VTdissipation)
+    CALL stop_timer(timer_dissip)
+    CALL VTb(VThallo)
+    !$OMP END MASTER
+
+    CALL Register_SwapField_u(ucov, ucov_dyn, distrib_caldyn, Request_dissip)
+    CALL Register_SwapField_v(vcov, vcov_dyn, distrib_caldyn, Request_dissip)
+    CALL Register_SwapField_u(teta, teta_dyn, distrib_caldyn, Request_dissip)
+    CALL Register_SwapField_u(p, p_dyn, distrib_caldyn, Request_dissip)
+    CALL Register_SwapField_u(pk, pk_dyn, distrib_caldyn, Request_dissip)
+
+    CALL SendRequest(Request_dissip)
+
+    !$OMP BARRIER
+    CALL WaitRequest(Request_dissip)
+    !$OMP BARRIER
+    !$OMP MASTER
+    CALL set_distrib(distrib_caldyn)
+    CALL VTe(VThallo)
+    CALL resume_timer(timer_caldyn)
+    !        print *,'fin dissipation'
+    !$OMP END MASTER
+    !$OMP BARRIER
+
+  END SUBROUTINE call_dissip
+
+END MODULE call_dissip_mod
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/conf_gcm.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/conf_gcm.F90	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/conf_gcm.F90	(revision 5101)
@@ -346,5 +346,5 @@
   CALL getin('maxlatfilter',maxlatfilter)
   if (maxlatfilter > 90) &
-       call abort_gcm("conf_gcm", 'maxlatfilter should be <=90', 1)
+       CALL abort_gcm("conf_gcm", 'maxlatfilter should be <=90', 1)
   
 
@@ -353,7 +353,7 @@
   CALL getin('ngroup',ngroup)
   IF (mod(iim, 2**ngroup) /= 0) &
-       call abort_gcm("conf_gcm", 'iim must be multiple of 2**ngroup', 1)
+       CALL abort_gcm("conf_gcm", 'iim must be multiple of 2**ngroup', 1)
   IF (2**ngroup > jjm + 1) &
-       call abort_gcm("conf_gcm", '2**ngroup must be <= jjm + 1', 1)
+       CALL abort_gcm("conf_gcm", '2**ngroup must be <= jjm + 1', 1)
 
   ! mode_top_bound : fields towards which sponge relaxation will be done:
@@ -365,5 +365,5 @@
   CALL getin('iflag_top_bound',iflag_top_bound)
   IF (iflag_top_bound < 0 .or. iflag_top_bound > 2) &
-       call abort_gcm("conf_gcm", 'iflag_top_bound must be 0, 1 or 2', 1)
+       CALL abort_gcm("conf_gcm", 'iflag_top_bound must be 0, 1 or 2', 1)
 
   ! mode_top_bound : fields towards which sponge relaxation will be done:
@@ -401,5 +401,5 @@
   CALL getin('ok_guide',ok_guide)
 
-  IF (ok_guide .and. adjust) call abort_gcm("conf_gcm", &
+  IF (ok_guide .and. adjust) CALL abort_gcm("conf_gcm", &
        "adjust does not work with ok_guide", 1)
 
@@ -812,5 +812,5 @@
      dzoomx = 0.2
      CALL getin('dzoomx',dzoomx)
-     call assert(dzoomx < 1, "conf_gcm: dzoomx must be < 1")
+     CALL assert(dzoomx < 1, "conf_gcm: dzoomx must be < 1")
 
      !Config  Key  = dzoomy
@@ -821,5 +821,5 @@
      dzoomy = 0.2
      CALL getin('dzoomy',dzoomy)
-     call assert(dzoomy < 1, "conf_gcm: dzoomy must be < 1")
+     CALL assert(dzoomy < 1, "conf_gcm: dzoomy must be < 1")
 
      !Config  Key  = taux
@@ -940,5 +940,5 @@
      vert_prof_dissip = merge(1, 0, ok_strato .and. llm==39)
      CALL getin('vert_prof_dissip', vert_prof_dissip)
-     call assert(vert_prof_dissip == 0 .or. vert_prof_dissip ==  1, &
+     CALL assert(vert_prof_dissip == 0 .or. vert_prof_dissip ==  1, &
           "bad value for vert_prof_dissip")
 
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dissip_loc.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dissip_loc.f90	(revision 5101)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dissip_loc.f90	(revision 5101)
@@ -0,0 +1,229 @@
+! $Id: $
+
+SUBROUTINE dissip_loc(vcov, ucov, teta, p, dv, du, dh)
+  !
+  USE parallel_lmdz
+  USE write_field_loc
+  USE dissip_mod, ONLY: dissip_allocate
+  USE comconst_mod, ONLY: dtdiss
+  USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_DEBUGIO
+  IMPLICIT NONE
+
+
+  ! ..  Avec nouveaux operateurs star :  gradiv2 , divgrad2, nxgraro2  ...
+  ! (  10/01/98  )
+
+  !=======================================================================
+  !
+  !   Auteur:  P. Le Van
+  !   -------
+  !
+  !   Objet:
+  !   ------
+  !
+  !   Dissipation horizontale
+  !
+  !=======================================================================
+  !-----------------------------------------------------------------------
+  !   Declarations:
+  !   -------------
+
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+  include "comdissnew.h"
+  include "comdissipn.h"
+
+  !   Arguments:
+  !   ----------
+
+  REAL, INTENT(IN) :: vcov(ijb_v:ije_v, llm) ! covariant meridional wind
+  REAL, INTENT(IN) :: ucov(ijb_u:ije_u, llm) ! covariant zonal wind
+  REAL, INTENT(IN) :: teta(ijb_u:ije_u, llm) ! potential temperature
+  REAL, INTENT(IN) :: p(ijb_u:ije_u, llmp1) ! interlayer pressure
+  ! ! tendencies (.../s) on covariant winds and potential temperature
+  REAL, INTENT(OUT) :: dv(ijb_v:ije_v, llm)
+  REAL, INTENT(OUT) :: du(ijb_u:ije_u, llm)
+  REAL, INTENT(OUT) :: dh(ijb_u:ije_u, llm)
+
+  !   Local:
+  !   ------
+
+  REAL :: gdx(ijb_u:ije_u, llm), gdy(ijb_v:ije_v, llm)
+  REAL :: grx(ijb_u:ije_u, llm), gry(ijb_v:ije_v, llm)
+  REAL :: te1dt(llm), te2dt(llm), te3dt(llm)
+  REAL :: deltapres(ijb_u:ije_u, llm)
+
+  INTEGER :: l, ij
+
+  REAL :: SSUM
+  integer :: ijb, ije
+
+  LOGICAl, SAVE :: first = .TRUE.
+  !$OMP THREADPRIVATE(first)
+
+  IF (first) THEN
+    CALL dissip_allocate
+    first = .FALSE.
+  ENDIF
+  !-----------------------------------------------------------------------
+  !   initialisations:
+  !   ----------------
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm
+    te1dt(l) = tetaudiv(l) * dtdiss
+    te2dt(l) = tetaurot(l) * dtdiss
+    te3dt(l) = tetah(l) * dtdiss
+  ENDDO
+  !$OMP END DO NOWAIT
+  ! CALL initial0( ijp1llm, du )
+  ! CALL initial0( ijmllm , dv )
+  ! CALL initial0( ijp1llm, dh )
+
+  ijb = ij_begin
+  ije = ij_end
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm
+    du(ijb:ije, l) = 0
+    dh(ijb:ije, l) = 0
+  ENDDO
+  !$OMP END DO NOWAIT
+
+  if (pole_sud) ije = ij_end - iip1
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm
+    dv(ijb:ije, l) = 0
+  ENDDO
+  !$OMP END DO NOWAIT
+
+  !-----------------------------------------------------------------------
+  !   Calcul de la dissipation:
+  !   -------------------------
+
+  !   Calcul de la partie   grad  ( div ) :
+  !   -------------------------------------
+
+  IF(lstardis) THEN
+    ! IF (.FALSE.) THEN
+    CALL gradiv2_loc(llm, ucov, vcov, nitergdiv, gdx, gdy)
+  ELSE
+    ! CALL gradiv_p ( llm,ucov,vcov,nitergdiv,gdx,gdy )
+  ENDIF
+
+  IF (CPPKEY_DEBUGIO) THEN
+    CALL WriteField_u('gdx', gdx)
+    CALL WriteField_v('gdy', gdy)
+  END IF
+
+  ijb = ij_begin
+  ije = ij_end
+  if (pole_sud) ije = ij_end - iip1
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm
+    if (pole_nord) then
+      DO ij = 1, iip1
+        gdx(ij, l) = 0.
+      ENDDO
+    endif
+
+    if (pole_sud) then
+      DO ij = 1, iip1
+        gdx(ij + ip1jm, l) = 0.
+      ENDDO
+    endif
+
+    if (pole_nord) ijb = ij_begin + iip1
+    DO ij = ijb, ije
+      du(ij, l) = du(ij, l) - te1dt(l) * gdx(ij, l)
+    ENDDO
+
+    if (pole_nord) ijb = ij_begin
+    DO ij = ijb, ije
+      dv(ij, l) = dv(ij, l) - te1dt(l) * gdy(ij, l)
+    ENDDO
+
+  ENDDO
+  !$OMP END DO NOWAIT
+  !   calcul de la partie   n X grad ( rot ):
+  !   ---------------------------------------
+
+  IF(lstardis) THEN
+    ! IF (.FALSE.) THEN
+    CALL nxgraro2_loc(llm, ucov, vcov, nitergrot, grx, gry)
+  ELSE
+    ! CALL nxgrarot_p( llm,ucov, vcov, nitergrot,grx,gry )
+  ENDIF
+
+  IF (CPPKEY_DEBUGIO) THEN
+    CALL WriteField_u('grx', grx)
+    CALL WriteField_v('gry', gry)
+  END IF
+
+  ijb = ij_begin
+  ije = ij_end
+  if (pole_sud) ije = ij_end - iip1
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm
+
+    if (pole_nord) then
+      DO ij = 1, iip1
+        grx(ij, l) = 0.
+      ENDDO
+    endif
+
+    if (pole_nord) ijb = ij_begin + iip1
+    DO ij = ijb, ije
+      du(ij, l) = du(ij, l) - te2dt(l) * grx(ij, l)
+    ENDDO
+
+    if (pole_nord) ijb = ij_begin
+    DO ij = ijb, ije
+      dv(ij, l) = dv(ij, l) - te2dt(l) * gry(ij, l)
+    ENDDO
+
+  ENDDO
+  !$OMP END DO NOWAIT
+
+  !   calcul de la partie   div ( grad ):
+  !   -----------------------------------
+
+  IF(lstardis) THEN
+    ! IF (.FALSE.) THEN
+
+    ijb = ij_begin
+    ije = ij_end
+
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    DO l = 1, llm
+      DO ij = ijb, ije
+        deltapres(ij, l) = AMAX1(0., p(ij, l) - p(ij, l + 1))
+      ENDDO
+    ENDDO
+    !$OMP END DO NOWAIT
+    CALL divgrad2_loc(llm, teta, deltapres, niterh, gdx)
+  ELSE
+    ! CALL divgrad_p ( llm,teta, niterh, gdx        )
+  ENDIF
+
+  IF (CPPKEY_DEBUGIO) THEN
+    CALL WriteField_u('gdx', gdx)
+  END IF
+
+  ijb = ij_begin
+  ije = ij_end
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm
+    DO ij = ijb, ije
+      dh(ij, l) = dh(ij, l) - te3dt(l) * gdx(ij, l)
+    ENDDO
+  ENDDO
+  !$OMP END DO NOWAIT
+
+  RETURN
+END SUBROUTINE dissip_loc
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/divgrad2_loc.F
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/divgrad2_loc.F	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/divgrad2_loc.F	(revision 5101)
@@ -50,8 +50,8 @@
 c
 c$OMP BARRIER
-       call Register_Hallo_u(divgra,llm,1,1,1,1,Request_dissip)
-       call SendRequest(Request_dissip)
+       CALL Register_Hallo_u(divgra,llm,1,1,1,1,Request_dissip)
+       CALL SendRequest(Request_dissip)
 c$OMP BARRIER
-       call WaitRequest(Request_dissip)
+       CALL WaitRequest(Request_dissip)
 c$OMP BARRIER
 
@@ -79,8 +79,8 @@
       DO  iter = 1, lh - 2
 c$OMP BARRIER
-       call Register_Hallo_u(divgra,llm,1,1,1,1,Request_dissip)
-       call SendRequest(Request_dissip)
+       CALL Register_Hallo_u(divgra,llm,1,1,1,1,Request_dissip)
+       CALL SendRequest(Request_dissip)
 c$OMP BARRIER
-       call WaitRequest(Request_dissip)
+       CALL WaitRequest(Request_dissip)
 
 c$OMP BARRIER
@@ -102,8 +102,8 @@
 c
 c$OMP BARRIER
-       call Register_Hallo_u(divgra,llm,1,1,1,1,Request_dissip)
-       call SendRequest(Request_dissip)
+       CALL Register_Hallo_u(divgra,llm,1,1,1,1,Request_dissip)
+       CALL SendRequest(Request_dissip)
 c$OMP BARRIER
-       call WaitRequest(Request_dissip)
+       CALL WaitRequest(Request_dissip)
 c$OMP BARRIER
 
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dynetat0_loc.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dynetat0_loc.F90	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dynetat0_loc.F90	(revision 5101)
@@ -9,6 +9,6 @@
   USE infotrac,    ONLY: nqtot, tracers, niso, iqIsoPha, iH2O, isoName
   USE strings_mod, ONLY: maxlen, msg, strStack, real2str, int2str, strIdx
-  USE netcdf,      ONLY: nf90_open,  nf90_nowrite, nf90_inquire_dimension, NF90_INQ_VARID, &
-                         nf90_close, nf90_get_var, NF90_INQUIRE_VARIABLE,  nf90_noerr
+  USE netcdf,      ONLY: nf90_open,  nf90_nowrite, nf90_inquire_dimension, nf90_inq_varid, &
+                         nf90_close, nf90_get_var, nf90_inquire_variable,  nf90_noerr
   USE readTracFiles_mod, ONLY: new2oldH2O, newHNO3, oldHNO3, getKey
   USE control_mod, ONLY: planet_type
@@ -122,8 +122,8 @@
 
   var="temps"
-  IF(NF90_INQ_VARID(fID,var,vID)/=nf90_noerr) THEN
+  IF(nf90_inq_varid(fID,var,vID)/=nf90_noerr) THEN
     CALL msg('missing field <temps> ; trying with <Time>', modname)
     var="Time"
-    CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+    CALL err(nf90_inq_varid(fID,var,vID),"inq",var)
   END IF
   CALL err(nf90_get_var(fID,vID,time),"get",var)
@@ -157,5 +157,5 @@
   ll = .FALSE.
 #ifdef REPROBUS
-  ll = NF90_INQ_VARID(fID, 'HNO3tot', vID) /= nf90_noerr                                 !--- DETECT OLD REPRO start.nc FILE
+  ll = nf90_inq_varid(fID, 'HNO3tot', vID) /= nf90_noerr                                 !--- DETECT OLD REPRO start.nc FILE
 #endif
   DO iq=1,nqtot
@@ -170,8 +170,8 @@
     END IF
     !--------------------------------------------------------------------------------------------------------------------------
-    IF(NF90_INQ_VARID(fID, var, vID) == nf90_noerr .AND. .NOT.lSkip) THEN                !=== REGULAR CASE: AVAILABLE VARIABLE
+    IF(nf90_inq_varid(fID, var, vID) == nf90_noerr .AND. .NOT.lSkip) THEN                !=== REGULAR CASE: AVAILABLE VARIABLE
       CALL get_var2(var,q_glo); q(ijb_u:ije_u,:,iq)=q_glo(ijb_u:ije_u,:)
     !--------------------------------------------------------------------------------------------------------------------------
-    ELSE IF(NF90_INQ_VARID(fID, oldVar, vID) == nf90_noerr) THEN                         !=== TRY WITH ALTERNATE NAME
+    ELSE IF(nf90_inq_varid(fID, oldVar, vID) == nf90_noerr) THEN                         !=== TRY WITH ALTERNATE NAME
       CALL msg('Tracer <'//TRIM(var)//'> is missing => initialized to <'//TRIM(oldVar)//'>', modname)
       CALL get_var2(oldVar, q_glo); q(ijb_u:ije_u,:,iq)=q_glo(ijb_u:ije_u,:)
@@ -238,10 +238,10 @@
   INTEGER :: nn(3), dids(3), k, nd, ntot
 
-  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
-  ierr=NF90_INQUIRE_VARIABLE(fID,vID,ndims=nd)
+  CALL err(nf90_inq_varid(fID,var,vID),"inq",var)
+  ierr=nf90_inquire_variable(fID,vID,ndims=nd)
   IF(nd==1) THEN
     CALL err(nf90_get_var(fID,vID,v),"get",var); RETURN
   END IF
-  ierr=NF90_INQUIRE_VARIABLE(fID,vID,dimids=dids)
+  ierr=nf90_inquire_variable(fID,vID,dimids=dids)
   DO k=1,nd; ierr=nf90_inquire_dimension(fID,dids(k),len=nn(k)); END DO
   ntot=PRODUCT(nn(1:nd))
@@ -263,11 +263,11 @@
 
 
-  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
-  ierr=NF90_INQUIRE_VARIABLE(fID,vID,ndims=nd)
+  CALL err(nf90_inq_varid(fID,var,vID),"inq",var)
+  ierr=nf90_inquire_variable(fID,vID,ndims=nd)
 
   IF(nd==1) THEN
     CALL err(nf90_get_var(fID,vID,v),"get",var); RETURN
   END IF
-  ierr=NF90_INQUIRE_VARIABLE(fID,vID,dimids=dids)
+  ierr=nf90_inquire_variable(fID,vID,dimids=dids)
 
   DO k=1,nd; ierr=nf90_inquire_dimension(fID,dids(k),len=nn(k)); END DO
